/*****************************************************
Solitario.java

Applet para jugar al juego del SOLITARIO

Mayo 98
******************************************************/

import java.applet.Applet;
import java.awt.*;
import java.applet.*;
import java.awt.event.*;

public class Solitario extends Applet
			implements MouseListener
{
    Color colorClaro = new Color(0xC66848);
    Color colorFondo = new Color(0xE68868);
    Color colorNormal = new Color(0xB65838);
    Color colorOscuro = new Color(0x963818);

	Image tablero, bola1, bola2, cavidad;
	
    static final int D = 36;
    int ancho, alto;    //Tamano del applet
	Graphics g;
	public casilla[][] casilla;
	int ficastocada, cocastocada;
	boolean bcastocada = false;
	
	public void tableroInicial(){
		//System.out.println("tableroInicial");
		for(int i = 0; i < 7; i++){
			for(int j = 0; j < 7; j++){
				casilla[i][j] = new casilla(-1,this);
			}
		}

		for(int i = 0; i < 7; i ++){
			for(int j = 2; j < 5; j++){
				casilla[i][j].setValue(1);
			}
		}
		for(int i = 2; i < 5; i ++){
			for(int j = 0; j < 7; j++){
				casilla[i][j].setValue(1);
			}
		}
		casilla[3][3].setValue(0);
	}

    ////////////////////////////////////////////
    public void init(){

        ancho = 324;
        alto = 324;
		casilla = new casilla[7][7];
		tableroInicial();
		g = getGraphics();
		addMouseListener(this);
		MediaTracker tracker = new MediaTracker(this);
		tablero = getImage(getDocumentBase(), "Tablero.gif");
		tracker.addImage(tablero,0);
		bola1 = getImage(getDocumentBase(), "Bola1.gif");
		tracker.addImage(bola1,1);
		bola2 = getImage(getDocumentBase(), "Bola2.gif");
		tracker.addImage(bola2,2);
		cavidad = getImage(getDocumentBase(), "Cavidad.gif");
		tracker.addImage(cavidad,3);
		try{
			tracker.waitForAll();
		}catch(InterruptedException e){
			System.out.println("Problemas cargando las imagenes.");
		}
    }

    public synchronized void paint(Graphics g){
    Color colorVerde = new Color(0,255,0);

        //System.out.println("Pintando");
	Dimension dim = getSize();
	//System.out.println("Dimension = " + dim);
	Image db = createImage(ancho, alto); //dim.width, dim.height);
	Graphics gdb = db.getGraphics();
	gdb.setColor(Color.white);
	gdb.fillRect(0,0,dim.width, dim.height);
	//gdb.setColor(colorVerde);
	//gdb.fillOval(0,0,dim.width, dim.height);
	gdb.drawImage(tablero,0,0,this);
	for(int i = 0; i < 7; i++){
		for(int j = 0; j < 7; j++){
			casilla[i][j].pinta(gdb, i, j);
		}
	}
	g.drawImage(db, 0, 0, ancho, alto, this); //dim.width, dim.height, this);
    }
	public Point casillaTocada(Point p){
		Point cas = new Point();
		//System.out.println("Punto " + p);
		int fi = (p.x - D) / D;
		if((fi < 0) || (fi > 6)) fi = 0;
		int co = (p.y - D) / D;
		if((co < 0) || (co > 6)) co = 0;
		cas.x = fi;
		cas.y = co;
		return cas;
	}

	public Point bufada(int co0,int fi0, int co1, int fi1){
		Point fichaBuf = new Point(-1, -1);
		if((co0 < 0) || (co0 > 6) ||
		   (fi0 < 0) || (fi0 > 6) ||
			(co1 < 0) || (co1 > 6) ||
			(fi1 < 0) || (fi1 > 6)) return fichaBuf;
		if(casilla[co1][fi1].valor != 0) return fichaBuf;
		if(casilla[co0][fi0].valor != 2) return fichaBuf;
		if((fi1 == fi0 -2) && (co1 == co0) && (casilla[co0][fi0 - 1].valor == 1)){
		    fichaBuf.x = co0;
		    fichaBuf.y = fi0 - 1;
		    return fichaBuf;
		}
		if((fi1 == fi0 +2) && (co1 == co0) && (casilla[co0][fi0 + 1].valor == 1)){
		    fichaBuf.x = co0;
		    fichaBuf.y = fi0 + 1;
		    return fichaBuf;
		}
		if((fi1 == fi0) && (co1 == co0 - 2) && (casilla[co0 - 1][fi0].valor == 1)){
		    fichaBuf.x = co0 - 1;
		    fichaBuf.y = fi1;
		    return fichaBuf;
		}
		if((fi1 == fi0) && (co1 == co0 + 2) && (casilla[co0 + 1][fi0].valor == 1)){
		    fichaBuf.x = co0 + 1;
		    fichaBuf.y = fi1;
		    return fichaBuf;
		}
		return fichaBuf;
	}
    	public void mouseReleased(MouseEvent e){
        	//System.out.println("Tocada ficha. "+ casillaTocada(e.getPoint()));
		if(bcastocada){
			Point cas = casillaTocada(e.getPoint());
			//System.out.println("MouseReleases casillatocada =" + cas);
			Point buf = bufada(cocastocada, ficastocada, cas.x, cas.y);
			//System.out.println("Casilla buf = " + buf);
			if(buf.x != -1){
				casilla[cocastocada][ficastocada].setValue(0);
				casilla[cocastocada][ficastocada].pinta(g, cocastocada, ficastocada);
				casilla[cas.x][cas.y].setValue(1);
				casilla[cas.x][cas.y].pinta(g, cas.x, cas.y);
				casilla[buf.x][buf.y].setValue(0);
				casilla[buf.x][buf.y].pinta(g, buf.x, buf.y);
			//	repaint();
			}else{
				casilla[cocastocada][ficastocada].setValue(1);
				casilla[cocastocada][ficastocada].pinta(g, cocastocada, ficastocada);
				casilla[cas.x][cas.y].pinta(g, cas.x, cas.y);
			}
			bcastocada = false;

		}
    	}

    	public void mousePressed(MouseEvent e){
		Point cas = casillaTocada(e.getPoint());
        	//System.out.println("Tocada ficha. "+ cas);
		if (casilla[cas.x][cas.y].valor == 1){
			bcastocada = true;
			ficastocada = cas.y;
			cocastocada = cas.x;
			casilla[cas.x][cas.y].setValue(2);
			casilla[cas.x][cas.y].pinta(g, cas.x, cas.y);
			//System.out.println("Casilla bien tocada");
		}else{
			//System.out.println("Casilla mal tocada");
		}
    	}

    	public void mouseEntered(MouseEvent e){
    	}

    	public void mouseExited(MouseEvent e){
		if (bcastocada){
			bcastocada = true;
			casilla[cocastocada][ficastocada].setValue(1);
			casilla[cocastocada][ficastocada].pinta(g, cocastocada, ficastocada);
			bcastocada = false;
		}
   	}

    	public void mouseClicked(MouseEvent e){
    	}

}

class casilla

{
	int valor;
	Solitario solitario;
	
    public casilla(int valor, Solitario solitario){
		this.valor = valor;
		this.solitario = solitario;
    }

	public void setValue(int v){
		valor = v;
	}
    public void pinta(Graphics g, int i,int j){
 	  Color colorVerde = new Color(0,255,0);
 	  Color colorVerdeOs = new Color(37, 163,48);
  	  Color colorRojo = new Color(255,0,0);
  	  Color colorRojo2 = new Color(197,31,31);
  	  Color colorMarron = new Color(173,112,8);
        int ancho = 36;
	int v0x = ancho * (i + 1) ;
	int v0y = ancho * (j + 1);
	if(valor == 0){
			g.drawImage(solitario.tablero,
						v0x,v0y,v0x + ancho, v0y + ancho,
						v0x,v0y,v0x + ancho, v0y + ancho,
						solitario);
            // g.setColor(colorMarron);
             //g.drawOval(v0x+5,v0y+5,ancho-10,ancho-10);
             //g.drawImage(solitario.cavidad,v0x,v0y,solitario);
	}else if (valor == 1){
             //g.setColor(colorRojo);
             //g.fillOval(v0x+1,v0y+1,ancho-1,ancho-1);
             g.drawImage(solitario.bola1,v0x,v0y,solitario);
	}else if (valor == 2){
             //g.setColor(colorRojo2);
             //g.fillOval(v0x+1,v0y+1,ancho-1,ancho-1);
             g.drawImage(solitario.bola2,v0x,v0y,solitario);
	}
    }
/************************
    public void mueve(int fi, int co){
        System.out.println("Moviendo a fi :"+fi+" colu: "+co);
        fila = fi;
        colu = co;
    }
****************************/
}
